<template>
  <GenericLayout>
    <template #header>
      <Header
        :back-button="true"
        :title="pageTitle"
      />
    </template>

    <template
      #page-content
    >
      <div class="full-height column">
        <template v-if="isDesktopPlatform">
          <div
            class="page-title"
            v-if="pageTitle"
          >
            {{ pageTitle }}
          </div>
          <div
            class="page-subtitle"
            v-if="pageSubTitle"
          >
            {{ pageSubTitle }}
          </div>
        </template>

        <q-card
          :square="!isDesktopPlatform"
          class="column no-wrap col"
        >
          <q-banner
            class="bg-grey-3 text-grey-8 q-mb-sm"
          >
            <translate>The soil data is used to compute the nutrients provided by the soil.</translate>
          </q-banner>

          <q-card-section>
            <div class="text-grey-8 q-mb-xs">
              <translate>Do you want to use soil data to compute nutrient requirements?</translate>
            </div>
            <q-btn-toggle
              v-model="storeSoilDataIsUsed"
              :options="[{value: true, label: $gettext('Yes')}, {value: false, label: $gettext('No')}]"
              toggle-color="primary"
            />
          </q-card-section>

          <div v-if="storeSoilDataIsUsed">
            <q-card-section>
              <q-select
                v-model="storeSoilDensity"
                :options="soilDensityOptions"
                option-value="name"
                option-label="description"
                filled
                :loading="loading"
                :label="$gettext('Soil type')"
              />

              <q-input
                v-model.number="storeSoilPH"
                filled
                type="number"
                :label="$gettext('pH')"
                :rules="[val => val > 0 || $gettext('This field must be positive')]"
                :min="0"
                step="0.1"
                hide-bottom-space
                :loading="loading"
                class="q-mt-md"
              />

              <q-input
                v-model.number="storeSoilPhosphorusContent"
                filled
                type="number"
                :label="$gettext('Phosphorus content')"
                :suffix="$gettext('mg/kg')"
                :rules="[val => val >= 0 || $gettext('This field must be positive or null')]"
                :min="0"
                step="0.1"
                hide-bottom-space
                :loading="loading"
                class="q-mt-md"
              />

              <q-input
                v-model.number="storeSoilPotassiumContent"
                filled
                type="number"
                :label="$gettext('Potassium content')"
                :suffix="$gettext('mg/kg')"
                :rules="[val => val >= 0 || $gettext('This field must be positive or null')]"
                :min="0"
                step="0.1"
                hide-bottom-space
                :loading="loading"
                class="q-mt-md"
              />

              <q-input
                v-model.number="storeSoilMagnesiumContent"
                filled
                type="number"
                :label="$gettext('Magnesium content')"
                :suffix="$gettext('mg/kg')"
                :rules="[val => val >= 0 || $gettext('This field must be positive or null')]"
                :min="0"
                step="0.1"
                hide-bottom-space
                :loading="loading"
                class="q-mt-md"
              />
            </q-card-section>
          </div>

          <!-- buttons -->
          <q-card-section class="q-mt-auto">
            <q-card-actions
              class="q-pa-none"
              vertical
              align="stretch"
            >
              <q-btn
                color="primary"
                text-color="white"
                :disable="!canContinue"
                @click="onClickNext"
              >
                <translate>Next</translate>
              </q-btn>
              <q-btn
                flat
                color="primary"
                @click="onClickPrevious"
              >
                <translate>Previous</translate>
              </q-btn>
            </q-card-actions>
          </q-card-section>
        </q-card>
      </div>
    </template>

    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'
import AlgorithmsMixins from 'src/pages/fieldbook/fertilization/algorithms/common/mixins/AlgorithmsMixins'
import queryKalkulackyHnojenieSoilDensityType from 'src/pages/fieldbook/fertilization/algorithms/kalkulacky-hnojenie/graphql/queryKalkulackyHnojenieSoilDensityType'
import queryPlotConstraints from 'src/pages/fieldbook/fertilization/algorithms/common/graphql/queryPlotConstraints'
import querySoilDerivedObjectsByPlotId from 'src/pages/fieldbook/fertilization/algorithms/common/graphql/querySoilDerivedObjectsByPlotId'

const DEFAULT_SOIL_DENSITY_NAME = 'medium'

export default {
  name: 'KalkulackyHnojenieSoilPage',
  components: {
    GenericLayout,
    Header,
    Footer
  },
  mixins: [PlatformMixin, AlgorithmsMixins],
  data () {
    return {
      kalkulackyHnojenieSoilDensities: null,
      plotSoilDerivedPropertyMap: null
    }
  },
  computed: {
    pageTitle () {
      return this.$gettext('Soil')
    },
    pageSubTitle () {
      return 'Kalkulacky Hnojenie'
    },
    canContinue () {
      return !this.loading &&
        this.isParameterSet(this.storeSoilDataIsUsed) &&
        (!this.storeSoilDataIsUsed || (
          this.isParameterSet(this.storeSoilDensity) &&
          this.isParameterSet(this.storeSoilPH) &&
          this.isParameterSet(this.storeSoilPhosphorusContent) &&
          this.isParameterSet(this.storeSoilPotassiumContent) &&
          this.isParameterSet(this.storeSoilMagnesiumContent)
        ))
    },
    loading () {
      return !this.kalkulackyHnojenieSoilDensities || !this.plotSoilDerivedPropertyMap
    },
    plotId () {
      return this.$store.state.fertilizationPlan.target.id
    },
    soilDensityOptions () {
      return this.kalkulackyHnojenieSoilDensities || []
    },
    storeSoilDataIsUsed: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.soilDataIsUsed
      },
      set (v) {
        this.updateParameter('soilDataIsUsed', v)
      }
    },
    storeSoilDensity: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.soilDensity
      },
      set (v) {
        this.updateParameter('soilDensity', v)
      }
    },
    storeSoilPH: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.soilPH
      },
      set (v) {
        this.updateParameter('soilPH', v)
      }
    },
    storeSoilPhosphorusContent: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.soilPhosphorusContent
      },
      set (v) {
        this.updateParameter('soilPhosphorusContent', v)
      }
    },
    storeSoilPotassiumContent: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.soilPotassiumContent
      },
      set (v) {
        this.updateParameter('soilPotassiumContent', v)
      }
    },
    storeSoilMagnesiumContent: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.soilMagnesiumContent
      },
      set (v) {
        this.updateParameter('soilMagnesiumContent', v)
      }
    },
    storeIsInNVZ: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.isInNVZ
      },
      set (v) {
        this.updateParameter('isInNVZ', v)
      }
    }
  },
  async mounted () {
    // Load data from cache (or online if not in cache)
    await this.loadData('cache-first')

    // Set default values from the plot soil derived observations
    if (!this.isParameterSet(this.storeSoilPH)) {
      this.storeSoilPH = this.roundIfNeeded(this.plotSoilDerivedPropertyMap?.ph, 1)
    }
    if (!this.isParameterSet(this.storeSoilPhosphorusContent)) {
      this.storeSoilPhosphorusContent = this.roundIfNeeded(this.plotSoilDerivedPropertyMap?.phosphorus, 0)
    }
    if (!this.isParameterSet(this.storeSoilPotassiumContent)) {
      this.storeSoilPotassiumContent = this.roundIfNeeded(this.plotSoilDerivedPropertyMap?.potassium, 0)
    }
    if (!this.isParameterSet(this.storeSoilMagnesiumContent)) {
      this.storeSoilMagnesiumContent = this.roundIfNeeded(this.plotSoilDerivedPropertyMap?.magnesium, 0)
    }

    // Refresh online data (do not wait until completion)
    this.loadData('network-only')
  },
  methods: {
    onClickNext () {
      // reset relevant fields when soil data is not used
      if (!this.storeSoilDataIsUsed) {
        this.storeSoilDensity = null
        this.soilPH = null
        this.soilPhosphorusContent = null
        this.soilPotassiumContent = null
        this.soilMagnesiumContent = null
      }

      // reset relevant fields when the plot is not in a NVZ
      if (!this.storeIsInNVZ) {
        this.storeSoilNitrogenMineralization = null
        this.storeGrowingSeasonDuration = null
      }

      const nextRouteName = this.storeIsInNVZ ? 'kalkulackyHnojenieNVZ' : 'kalkulackyHnojenieNutrientRequirements'
      this.$router.push({
        name: nextRouteName
      })
    },
    onClickPrevious () {
      this.$router.replace({
        name: 'kalkulackyHnojenieCropProfile'
      })
    },
    roundIfNeeded (number, decimalPlaces = 0) {
      if (number == null) {
        return number
      } else {
        const factorOfTen = Math.pow(10, decimalPlaces)
        return Math.round(number * factorOfTen) / factorOfTen
      }
    },
    async loadSoilDensities (fetchPolicy) {
      const { data } = await this.$apollo.query({
        query: queryKalkulackyHnojenieSoilDensityType,
        fetchPolicy
      })
      this.kalkulackyHnojenieSoilDensities = data?.__type.enumValues
      const defaultDensity = this.kalkulackyHnojenieSoilDensities.find(density => density.name === DEFAULT_SOIL_DENSITY_NAME)
      if (defaultDensity) {
        this.storeSoilDensity = defaultDensity
      }
    },
    async computeIsInNVZ (fetchPolicy) {
      const { data } = await this.$apollo.query({
        query: queryPlotConstraints,
        variables: {
          plotId: this.plotId
        },
        fetchPolicy
      })
      this.storeIsInNVZ = data?.plotConstraints?.filter(constraint => constraint.name === 'management_restriction_or_regulation_zone').length > 0
    },
    async loadSoilProperties (fetchPolicy) {
      try {
        const { data } = await this.$apollo.query({
          query: querySoilDerivedObjectsByPlotId,
          variables: {
            plot_id: this.plotId
          },
          fetchPolicy
        })
        this.plotSoilDerivedPropertyMap = {}
        const derivedObservations = data?.soil_derived_object?.[0]?.derived_observations || []
        for (const observation of derivedObservations) {
          this.plotSoilDerivedPropertyMap[observation.observed_property_id] = observation.result.value || null
        }
      } catch (e) {
        console.error('Could not load soil properties', e)
        this.plotSoilDerivedPropertyMap = {}
      }
    },
    loadData (fetchPolicy) {
      return Promise.all([
        this.computeIsInNVZ(fetchPolicy),
        this.loadSoilDensities(fetchPolicy),
        this.loadSoilProperties(fetchPolicy)
      ])
    }
  }
}
</script>
